<?php
// $Id: b2extraoptions.install.php,v 1.1 2002/11/28 23:31:33 zed1 Exp $
//
// B2 Extra Options
// Copyright (C) 2002 Mike Little -- mike@zed1.com
//
// This is an add-on to b2 weblog / news publishing tool
// b2 is copyright (c)2001, 2002 by Michel Valdrighi - m@tidakada.com
//
// **********************************************************************
// Copyright (C) 2002 Mike Little
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Mike Little (mike@zed1.com)
// *****************************************************************

// Start Connect To MYSQL
require_once("b2config.php");
include_once("$b2inc/b2vars.php");
include_once("$b2inc/b2functions.php");

$tableextraoptions = "b2extraoptions";
$tableextraoptiontypes = "b2optiontypes";


$got_options = false;
$got_types = false;

?><html>
<head>
<title>b2 > Installation</title>
</head>
<body>
<p>Checking for tables...</p>
<?php
$result = mysql_list_tables($dbname);
if (!$result) {
    print "DB Error, could not list tables\n";
    print 'MySQL Error: ' . mysql_error();
    exit;
}

while ($row = mysql_fetch_row($result)) {
    if ($row[0] == $tableextraoptions)
        $got_options = true;
    if ($row[0] == $tableextraoptiontypes)
        $got_types = true;
    //print "Table: $row[0]<br />\n";
}
if (!$got_types) {
    echo "<p>Can't find table '$tableextraoptiontypes', gonna create it...</p>\n";
    $sql = "CREATE TABLE $tableextraoptiontypes ( " .
           "  option_id int(11) NOT NULL auto_increment, " .
           "  option_name tinytext NOT NULL,             ".
           "  PRIMARY KEY (option_id)                    ".
           ") ";
    $result = mysql_query($sql) or print ("Can't create the table '$tableextraoptiontypes' in the database.<br />" . $sql . "<br />" . mysql_error());
    if ($result != false) {
        echo "<p>Table '$tableextraoptiontypes' created OK</p>\n";
        $got_types = true;
    }
} else {
    echo "<p>Found table '$tableextraoptiontypes', don't need to create it...</p>\n";
}

if (!$got_options) {
    echo "<p>Can't find '$tableextraoptions', gonna create it...</p>\n";
    $sql = "CREATE TABLE $tableextraoptions ( " .
           "  option_id int(11) NOT NULL auto_increment,             " .
           "  option_name varchar(64) UNIQUE NOT NULL default '',    " .
           "  option_type int(11) NOT NULL default 1,                " .
           "  option_value varchar(255) NOT NULL default '',         " .
           "  option_description varchar(255) NOT NULL default '',   " .
           "  option_level int NOT NULL DEFAULT '1',                 " .
           "  PRIMARY KEY (option_id)                                " .
           ") ";
    $result = mysql_query($sql) or print ("Can't create the table '$tableextraoptions' in the database.<br />" . $sql . "<br />" . mysql_error());
    if ($result != false) {
        echo "<p>Table '$tableextraoptions' created OK</p>\n";
        $got_options = true;
    }
} else {
    echo "<p>Found table '$tableextraoptions', don't need to create it...</p>\n";
}

if ($got_options && $got_types) {
    $got_1 = false;
    $got_2 = false;
    $got_3 = false;
    $got_4 = false;

    echo "<p>Looking for types...</p>\n";
    $sql = "SELECT option_id, option_name FROM $tableextraoptiontypes ";
    $result = mysql_query($sql) or print ("Can't query '$tableextraoptiontypes'.<br />" . $sql . "<br />" . mysql_error());
    if ($result != false) {
        while ($row = mysql_fetch_object($result)) {
            if ($row->{'option_id'} == 1) {
                echo "<p>You have got type 1. Good!</p>\n";
            $got_1 = true;
            }
            if ($row->{'option_id'} == 2) {
                echo "<p>You have got type 2. Good!</p>\n";
            $got_2 = true;
            }
            if ($row->{'option_id'} == 3) {
                echo "<p>You have got type 3. Good!</p>\n";
            $got_3 = true;
            }
            if ($row->{'option_id'} == 4) {
                echo "<p>You have got type 4. Good!</p>\n";
            $got_4 = true;
            }
        }

        if (!$got_1) {
            echo "<p>Gonna insert type 1...</p>\n";
            $sql = "INSERT INTO $tableextraoptiontypes (option_id, option_name) VALUES (1, 'int')";
            $result = mysql_query($sql) or print ("Can't insert type.<br />" . $sql . "<br />" . mysql_error());
            if ($result != false) {
                echo "<p>Inserted type Ok</p>\n";
                $got_1 = true;
            }
        }
        if (!$got_2) {
            echo "<p>Gonna insert type 2...</p>\n";
            $sql = "INSERT INTO $tableextraoptiontypes (option_id, option_name) VALUES (2, 'boolean')";
            $result = mysql_query($sql) or print ("Can't insert type.<br />" . $sql . "<br />" . mysql_error());
            if ($result != false) {
                echo "<p>Inserted type Ok</p>\n";
                $got_2 = true;
            }
        }
        if (!$got_3) {
            echo "<p>Gonna insert type 3...</p>\n";
            $sql = "INSERT INTO $tableextraoptiontypes (option_id, option_name) VALUES (3, 'string')";
            $result = mysql_query($sql) or print ("Can't insert type.<br />" . $sql . "<br />" . mysql_error());
            if ($result != false) {
                echo "<p>Inserted type Ok</p>\n";
                $got_3 = true;
            }
        }
        if (!$got_4) {
            echo "<p>Gonna insert type 4...</p>\n";
            $sql = "INSERT INTO $tableextraoptiontypes (option_id, option_name) VALUES (4, 'date')";
            $result = mysql_query($sql) or print ("Can't insert type.<br />" . $sql . "<br />" . mysql_error());
            if ($result != false) {
                echo "<p>Inserted type Ok</p>\n";
                $got_4 = true;
            }
        }
    } else {
        echo ("No results from query '$tableextraoptiontypes'.<br />" . $sql . "<br />" . mysql_error());
    }


    $got_option_1 = false;
    $got_option_2 = false;

    echo "<p>Looking for extra options...</p>\n";
    $sql = "SELECT option_name FROM $tableextraoptions ";
    $result = mysql_query($sql) or print ("Can't query '$tableextraoptions'.<br />" . $sql . "<br />" . mysql_error());
    if ($result != false) {
        while ($row = mysql_fetch_object($result)) {
            if ($row->{'option_name'} == 'add_options_min_level') {
                echo "<p>You have got 'add_options_min_level'. Good!</p>\n";
            $got_option_1 = true;
            }
            if ($row->{'option_name'} == 'blog_closed') {
                echo "<p>You have got 'blog_closed'. Good!</p>\n";
            $got_option_2 = true;
            }
        }

        if (!$got_option_1) {
            echo "<p>Gonna insert extra option 1...</p>\n";
            $sql = "INSERT INTO $tableextraoptions " .
                   " (option_id, option_name, option_type, option_value, option_description, option_level) " .
                   " VALUES (1,'add_options_min_level', 1, '10','The minimum user level to add/edit extra options.', 10)";
            $result = mysql_query($sql) or print ("Can't query extra option.<br />" . $sql . "<br />" . mysql_error());
            if ($result != false) {
                echo "<p>Inserted extra option Ok</p>\n";
                $got_option_1 = true;
            }
        }
        if (!$got_option_2) {
            echo "<p>Gonna insert extra option 2...</p>\n";
            $sql = "INSERT INTO $tableextraoptions " .
                   " (option_id, option_name, option_type, option_value, option_description, option_level) " .
                   " VALUES (2,'blog_closed', 2, 'false','Set this to true to temporarily close the blog.', 5)";
            $result = mysql_query($sql) or print ("Can't query extra option.<br />" . $sql . "<br />" . mysql_error());
            if ($result != false) {
                echo "<p>Inserted extra option Ok</p>\n";
                $got_option_2 = true;
            }
        }
    }

}

if ($got_1 && $got_2 && $got_3 && $got_4 && $got_option_1 && $got_option_2) {
    echo "<p>All done.</p>\n";
}
?>
</body>
</html>
