--  --------------------------------------------------------
-- // $Id: b2extraoptions.sql,v 1.1 2002/11/20 00:06:39 zed1 Exp $
-- //
-- // B2 Extra Options
-- // Copyright (C) 2002 Mike Little -- mike@zed1.com
-- //
-- // This is an add-on to b2 weblog / news publishing tool
-- // b2 is copyright (c)2001, 2002 by Michel Valdrighi - m@tidakada.com
-- //
-- // **********************************************************************
-- // Copyright (C) 2002 Mike Little
-- //
-- // This program is free software; you can redistribute it and/or modify
-- // it under the terms of the GNU General Public License as published by
-- // the Free Software Foundation; either version 2 of the License, or
-- // (at your option) any later version.
-- //
-- // This program is distributed in the hope that it will be useful, but
-- // WITHOUT ANY WARRANTY; without even the implied warranty of
-- // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
-- // General Public License for more details.
-- //
-- // You should have received a copy of the GNU General Public License
-- // along with this program; if not, write to the Free Software
-- // Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-- //
-- // Mike Little (mike@zed1.com)
-- // *****************************************************************

DROP TABLE IF EXISTS b2extraoptions;
CREATE TABLE b2extraoptions (
  option_id int(11) NOT NULL auto_increment,
  option_name varchar(64) UNIQUE NOT NULL default '',
  option_type int(11) NOT NULL default 1,
  option_value varchar(255) NOT NULL default '',
  option_description varchar(255) NOT NULL default '',
  option_level int NOT NULL DEFAULT '1',
  PRIMARY KEY (option_id)
) TYPE=MyISAM;

INSERT INTO b2extraoptions (option_id, option_name, option_type, option_value, option_description, option_level)
VALUES(1,'add_options_min_level', 1, '10','The minimum user level to add/edit extra options.', 10);
INSERT INTO b2extraoptions (option_id, option_name, option_type, option_value, option_description, option_level)
VALUES(2,'blog_closed', 2, 'false','Set this to true to temporarily close the blog.', 5);

-- DROP TABLE IF EXISTS b2optiontypes;
CREATE TABLE b2optiontypes (
  option_id int(11) NOT NULL auto_increment,
  option_name tinytext NOT NULL,
  PRIMARY KEY (option_id)
) TYPE=MyISAM;

INSERT INTO b2optiontypes (option_id, option_name) VALUES (1, 'int');
INSERT INTO b2optiontypes (option_id, option_name) VALUES (2, 'boolean');
INSERT INTO b2optiontypes (option_id, option_name) VALUES (3, 'string');
INSERT INTO b2optiontypes (option_id, option_name) VALUES (4, 'date');

